Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /sml/trunk/config/install.sh
ViewVC logotype

Diff of /sml/trunk/config/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

sml/branches/SMLNJ/config/install.sh revision 429, Wed Sep 8 09:47:00 1999 UTC sml/trunk/config/install.sh revision 577, Fri Mar 10 08:07:18 2000 UTC
# Line 2  Line 2 
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4  #  #
5  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
6  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
7  #  #
8    # Significant changes to accommodate (and take advantage of) the new CM
9    # by M.Blume (2/2000).
10    #
11    
12  #set -x  this=$0
13    
14  #  #
15  # get the target list  # get the target list
16  #  #
17  if [ ! -r config/targets ]; then  if [ ! -r config/targets ]; then
18    echo "!!! File config/targets is missing."      echo "$this: !!! File config/targets is missing."
19    exit 1;      exit 1
20  fi  fi
21  . config/targets  . config/targets
22    
23  #  #
24  # some OSs have make in strange places  # create the preloads.standard file
25  #  #
26  MAKE=make  if [ ! -r config/preloads ]; then
27        echo "$this: !!! File config/preloads is missing."
28        exit 1
29    fi
30    cp config/preloads preloads.standard
31    
32  #  #
33  # check for ksh  # Some OSs have make in strange places, but most of the time it is
34  #  # simply on the PATH:
 # ksh causes some people problems so we will always use /bin/sh  
35  #  #
36  #echo "checking for ksh"  MAKE=make
37  #if [ -x /bin/ksh ]; then  
 #  SHELL=/bin/ksh  
 #elif [ -x /usr/local/bin/ksh ]; then  
 #  SHELL=/usr/local/bin/ksh  
 #else  
38    SHELL=/bin/sh    SHELL=/bin/sh
39  #fi  echo $this: Using shell $SHELL.
 echo Using shell $SHELL.  
40    
41  #  #
42  # set the SML root directory  # set the SML root directory
43  #  #
44  REAL_PWD=`pwd`  REAL_PWD=`pwd`
45  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
46  echo SML root is $ROOT.  echo $this: SML root is $ROOT.
47    echo $this: Installation directory is ${INSTALLDIR:=$ROOT}.
48    
49  #  #
50  # set the various directory and file pathname variables  # set the various directory and file pathname variables
51  #  #
52  BINDIR=$ROOT/bin                # main dir for binary stuff  BINDIR=$INSTALLDIR/bin          # main dir for binary stuff
53  CONFIGDIR=$ROOT/config  CONFIGDIR=$ROOT/config
54  HEAPDIR=$BINDIR/.heap           # where heap images live  HEAPDIR=$BINDIR/.heap           # where heap images live
55  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
56  SRCDIR=$ROOT/src                # where the source tree is rooted  SRCDIR=$ROOT/src                # where the source tree is rooted
57  LIBDIR=$ROOT/lib                # where libraries live  LIBDIR=$INSTALLDIR/lib          # where libraries live
58  LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries  LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries
59  LIBMOVESCRIPT=$ROOT/libmove     # a temporary script  LIBMOVESCRIPT=$ROOT/libmove     # a temporary script
60  LOCALPATHCONFIG=$ROOT/pathconfig # a temporary pathconfig file  LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file
61    
62    URLGETTER=unknown
63    
64  #  #
65  # the paths to ml-yacc, ml-burg, and ml-lex; needed to configure CM  # the path to the dir where ml-yacc, ml-burg, ml-lex, and ml-build live
66  #  #
67  YACCPATH=$BINDIR/ml-yacc  TOOLDIR=$BINDIR
68  LEXPATH=$BINDIR/ml-lex  
69  BURGPATH=$BINDIR/ml-burg  #
70    # files to be deleted after we are done...
71    #
72    tmpfiles=""
73    tmpfiles="$tmpfiles $ROOT/preloads.standard"
74    tmpfiles="$tmpfiles $LIBLIST"
75    tmpfiles="$tmpfiles $LOCALPATHCONFIG"
76    tmpfiles="$tmpfiles $LIBMOVESCRIPT"
77    #
78    # make sure we always clean up after ourselves...
79    #
80    trap 'rm -f $tmpfiles' 0 1 2 3 15
81    
82    
83  #  #
84  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
85  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
86  # Especially important is CM_PATHCONFIG_DEFAULT.  # Especially important is CM_PATHCONFIG_DEFAULT.
87  #  #
 CM_YACC_DEFAULT=$YACCPATH  
 CM_LEX_DEFAULT=$LEXPATH  
 CM_BURG_DEFAULT=$BURGPATH  
88  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig
89  export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATHCONFIG_DEFAULT  export CM_PATHCONFIG_DEFAULT
90    
91  #  #
92  # the release version that we are installing  # the release version that we are installing
93  #  #
94  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
95  echo Installing version $VERSION.  echo $this: Installing version $VERSION.
96    
97    #
98    # the URL for the (usually remote) source archive
99    #
100    SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
101    echo $this: URL of source archive is $SRCARCHIVEURL.
102    
103  #  #
104  # Function to make a directory (and advertise such action).  # Function to make a directory (and advertise such action).
105  #  #
106  makedir() {  makedir() {
107      if [ ! -d $1 ] ; then      if [ ! -d $1 ] ; then
108          echo Making directory $1          echo $this: Making directory $1
109          if mkdir $1 ; then          if mkdir $1 ; then
110              : everything is fine              : everything is fine
111          else          else
112              echo "!!! Unable to make directory $1!"              echo "$this: !!! Unable to make directory $1!"
113              exit 1              exit 1
114          fi          fi
115      fi      fi
116  }  }
117    
118  #  #
119    # Function for asking user to fetch source archive.
120    #   $1 - descriptive name
121    #   $2 - base name without extension, without version, and without dir
122    #   $3 - remote directory
123    #
124    askurl() {
125        echo $this: Please, fetch $1 archive '('$VERSION-$2.'*)' from
126        echo '  ' $3
127        echo "and then re-run this script!"
128        exit 1
129    }
130    
131    #
132    # Function for fetching source archives automatically using wget or lynx.
133    #   $1 - command to actually get the stuff
134    #   $2 - descriptive name
135    #   $3 - base name without extension, without version, and without dir
136    #   $4 - remote directory
137    #
138    fetchurl() {
139        getter=$1 ; shift
140        echo $this: Fetching $1 from $2. Please stand by...
141        fetched=no
142        for ext in tgz tar.gz tar.Z tz tar tar.bz2 ; do
143            try=$VERSION-$2.$ext
144            echo $this: Trying $try ...
145            if $getter $3 $try $ROOT/$try ; then
146                fetched=yes
147                echo $this: Fetching $try was a success.
148                break
149            else
150                rm -f $ROOT/$try
151            fi
152        done
153        if [ $fetched = no ] ; then
154            echo $this: Fetching $try was no success.
155            echo '  ' You should try to do it manually now.
156            askurl "$1" "$2" "$3"
157        fi
158    }
159    
160    usewget() {
161        wget -nv -O $3 $1/$2
162    }
163    
164    uselynx() {
165        lynx -source $1/$2 >$3
166    }
167    
168    testurlgetter() {
169        (exec >/dev/null 2>&1 ; exec $*)
170    }
171    
172    #
173    # Function to check whether wget or lynx is available.
174    # Set URLGETTER accordingly.
175    #
176    urlgetter() {
177        if [ "$URLGETTER" = unknown ] ; then
178            if testurlgetter wget --help ; then
179                URLGETTER="fetchurl usewget"
180            elif testurlgetter lynx -help ; then
181                URLGETTER="fetchurl uselynx"
182            else
183                URLGETTER="askurl"
184            fi
185        fi
186    }
187    
188    #
189  # Function to unpack a source archive.  # Function to unpack a source archive.
190  #  #
191  # $1: descriptive name of the sources to be unpacked  # $1: descriptive name of the sources to be unpacked
# Line 105  Line 194 
194  # $4: the basename of the source archive (the script will check several  # $4: the basename of the source archive (the script will check several
195  #     different suffixes to determine what kind of de-compression is to  #     different suffixes to determine what kind of de-compression is to
196  #     be used)  #     be used)
197  unpack() {  #
198      if [ ! -d $2/$3 ]; then  # fetch_n_unpack is the helper function that does the real work.  If
199          echo Unpacking $1 source files.  # on archive is found locally, it invokes $URLGETTER and tries again.
200    # The variable $tryfetch is used to make sure this happens only once.
201    fetch_n_unpack() {
202        larc=$ROOT/$VERSION-$4
203          cd $2          cd $2
204          if [ -r $4.tar.Z ] ; then      if [ -r $larc.tar.Z ] ; then
205              zcat $4.tar.Z | tar -xf -          echo "$this: Un-compress-ing and un-tar-ing $1 archive."
206          elif [ -r $4.tar ] ; then          zcat $larc.tar.Z | tar -xf -
207              tar -xf $4.tar      elif [ -r $larc.tar ] ; then
208          elif [ -r $4.tar.gz ] ; then          echo "$this: Un-tar-ing $1 archive."
209              gunzip -c $4.tar.gz | tar -xf -          tar -xf $larc.tar
210          elif [ -r $4.tar.bz2 ] ; then      elif [ -r $larc.tar.gz ] ; then
211              bunzip2 -c $4.tar.bz2 | tar -xf -          echo "$this: Un-gzip-ing and un-tar-ing $1 archive."
212          elif [ -r $4.tgz ] ; then          gunzip -c $larc.tar.gz | tar -xf -
213              gunzip -c $4.tgz | tar -xf -      elif [ -r $larc.tar.bz2 ] ; then
214          elif [ -r $4.tz ] ; then          echo "$this: Un-bzip2-ing and un-tar-ing $1 archive."
215              zcat $4.tz | tar -xf -          bunzip2 -c $larc.tar.bz2 | tar -xf -
216        elif [ -r $larc.tgz ] ; then
217            echo "$this: Un-gzip-ing and un-tar-ing $1 archive."
218            gunzip -c $larc.tgz | tar -xf -
219        elif [ -r $larc.tz ] ; then
220            echo "$this: Un-compress-ing and un-tar-ing $1 archive."
221            zcat $larc.tz | tar -xf -
222        elif [ $tryfetch = yes ] ; then
223            urlgetter
224            $URLGETTER "$1" $4 $SRCARCHIVEURL
225            tryfetch=no
226            fetch_n_unpack "$1" "$2" "$3" "$4"
227        fi
228    }
229    
230    #
231    # The main "unpack" driver function that invokes the above helper.
232    #
233    unpack() {
234        tryfetch=yes
235        if [ -d $2/$3 ]; then
236            echo "$this: The $1 tree already exists."
237          else          else
238              echo "!!! The $1 source files are missing."          fetch_n_unpack "$1" "$2" "$3" "$4"
             exit 1  
239          fi          fi
240          if [ ! -d $2/$3 ]; then          if [ ! -d $2/$3 ]; then
241              echo "!!! Unable to unpack $1 source files."          echo "$this: !!! Unable to unpack $1 archive."
242              exit 1              exit 1
243          fi          fi
244    }
245    
246    # A function to move all stable library files to a parallel directory
247    # hierarchy.
248    # The first argument must be a simple path (no / inside), and
249    # the second argument must be an absolute path.
250    move() {
251        if [ -d $1 ] ; then
252            if [ ! -d $2 ] ; then
253                if [ -f $2 ] ; then
254                    echo $this: $2 exists as a non-directory.
255                    exit 1
256                fi
257                mkdir $2
258            fi
259            cd $1
260            for i in * ; do
261                move $i $2/$i
262            done
263            cd ..
264        elif [ -f $1 ] ; then
265            rm -f $2
266            mv $1 $2
267      fi      fi
268  }  }
269    
# Line 137  Line 272 
272  # $LIBDIR/$2/CM/$ARCH-unix/$2 so that it appears as if the description file  # $LIBDIR/$2/CM/$ARCH-unix/$2 so that it appears as if the description file
273  # had been at $LIBDIR/$2/$2  # had been at $LIBDIR/$2/$2
274  #  #
275  movelib() {  # (This script will also move all other libraries that show up in
276      if [ -f $1/CM/$ARCH-unix/$2 ] ; then  #  $1/CM/$ARCH-unix because in the case of the boot directory this indicates
277          echo Moving library $2 to $LIBDIR.  #  that some library did not have its own path anchor but was specified
278    #  relative to $1/$2. Still, don't rely on this to be robust -- rather make
279    #  separate anchors for every library!)
280    #
281    movelibs() {
282        for lib in `/bin/ls $1/CM/$ARCH-unix` ; do
283            case $lib in
284            *.cm | *.cmi)
285                if [ $lib != $2 ] ; then
286                    echo "$this: Warning:" $lib specified relative to $2
287                fi
288                echo $this: Moving library $lib to $LIBDIR
289          makedir $LIBDIR/$2          makedir $LIBDIR/$2
290          makedir $LIBDIR/$2/CM          makedir $LIBDIR/$2/CM
291          makedir $LIBDIR/$2/CM/$ARCH-unix          makedir $LIBDIR/$2/CM/$ARCH-unix
292          mv $1/CM/$ARCH-unix/$2 $LIBDIR/$2/CM/$ARCH-unix/$2              mv $1/CM/$ARCH-unix/$lib $LIBDIR/$2/CM/$ARCH-unix/$lib
293      fi              ;;
294            *)
295                ;;
296            esac
297         done
298  }  }
299    
300  # A shell function that registers a library for being built.  # A shell function that registers a library for being built.
# Line 155  Line 305 
305  #  #
306  # This works by adding ML code to file $LIBLIST.  The code in this file  # This works by adding ML code to file $LIBLIST.  The code in this file
307  # will be executed near the end of this script.  If $MOVE_LIBRARIES is  # will be executed near the end of this script.  If $MOVE_LIBRARIES is
308  # set to true, then reglib will also register a "movelib" to be executed at  # set to true, then reglib will also register a "movelibs" to be executed at
309  # the end by putting a "movelib" line into $LIBMOVESCRIPT.  # the end by putting a "movelibs" line into $LIBMOVESCRIPT.
310    
311  reglib() {  reglib() {
312      if [ x$MOVE_LIBRARIES = xtrue ] ; then      if [ x$MOVE_LIBRARIES = xtrue ] ; then
# Line 164  Line 314 
314      else      else
315          FINALLOCATION=$SRCDIR/$2          FINALLOCATION=$SRCDIR/$2
316      fi      fi
317      if [ -d $FINALLOCATION ] ; then      if [ -d $FINALLOCATION/CM/$ARCH-unix ] ; then
318          echo "Library $1 already exists in $FINALLOCATION."          echo "$this: Library $1 already exists in $FINALLOCATION."
319      else      else
320          echo "Scheduling library $1 to be built in $FINALLOCATION."          echo "$this: Scheduling library $1 to be built in $FINALLOCATION."
321          echo "andalso CM.stabilize false \"$1\"" >>$LIBLIST          echo "andalso CM.stabilize false \"$1\"" >>$LIBLIST
322          echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG          echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG
323          if [ x$MOVE_LIBRARIES = xtrue ] ; then          if [ x$MOVE_LIBRARIES = xtrue ] ; then
324              echo movelib $SRCDIR/$2 $1 >>$LIBMOVESCRIPT              echo movelibs $SRCDIR/$2 $1 >>$LIBMOVESCRIPT
325          fi          fi
326          echo $1 $FINALLOCATION >>$CM_PATHCONFIG_DEFAULT          echo $1 $FINALLOCATION >>$CM_PATHCONFIG_DEFAULT
327      fi      fi
# Line 179  Line 329 
329    
330  #  #
331  # Function to build a standalone program such as ml-yacc.  The function takes  # Function to build a standalone program such as ml-yacc.  The function takes
332  # 2 or 3 arguments.  First the name of the program with at the same time  # 2 or 3 arguments.  First the name of the program which at the same time
333  # is the directory name under $SRCDIR where the sources reside.  The second  # is the directory name under $SRCDIR where the sources reside.  The second
334  # argument is a descriptive name for the program (passed on to "unpack").  # argument is a descriptive name for the program (passed on to "unpack").
335  # The optional third argument specifies the path relative to $SRCDIR/$1  # The optional third argument specifies the path relative to $SRCDIR/$1
# Line 194  Line 344 
344          TARGETLOC=$TARGET          TARGETLOC=$TARGET
345      fi      fi
346      if [ -r $HEAPDIR/$TARGET ] ; then      if [ -r $HEAPDIR/$TARGET ] ; then
347          echo Target $TARGET already exists.          echo $this: Target $TARGET already exists.
348      else      else
349          echo Building $TARGET.          echo $this: Building $TARGET.
350          unpack $2 $SRCDIR $1 $ROOT/$VERSION-$1          unpack $2 $SRCDIR $1 $1
351          cd $SRCDIR/$1          cd $SRCDIR/$1
352          ./build          ./build
353          if [ -r $TARGETLOC ] ; then          if [ -r $TARGETLOC ] ; then
# Line 207  Line 357 
357                  ln -s .run-sml $1                  ln -s .run-sml $1
358              fi              fi
359          else          else
360              echo "!!! Build of $TARGET failed."              echo "$this: !!! Build of $TARGET failed."
361          fi          fi
362      fi      fi
363  }  }
# Line 220  Line 370 
370      makedir $dir      makedir $dir
371  done  done
372    
   
373  #  #
374  # install the script that tests the architecture, and make sure that it works  # install the script that tests the architecture, and make sure that it works
375  #  #
376  if [ -x $BINDIR/.arch-n-opsys ]; then  if [ -x $BINDIR/.arch-n-opsys ]; then
377    echo Script $BINDIR/.arch-n-opsys already exists.      echo $this: Script $BINDIR/.arch-n-opsys already exists.
378  else  else
379    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys      cat $CONFIGDIR/_arch-n-opsys \
380        | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys
381    chmod 555 $BINDIR/.arch-n-opsys    chmod 555 $BINDIR/.arch-n-opsys
382    if [ ! -x $BINDIR/.arch-n-opsys ]; then    if [ ! -x $BINDIR/.arch-n-opsys ]; then
383      echo "!!! Installation of $BINDIR/.arch-n-opsys failed for some reason."          echo "$this: !!! Installation of $BINDIR/.arch-n-opsys failed."
384      exit 1      exit 1
385    fi    fi
386  fi  fi
387    
388  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
389  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
390    echo "!!! Script $BINDIR/.arch-n-opsys fails on this machine."      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
391    echo "!!! You must patch this by hand and repeat the installation."      echo "$this: !!! You must patch this by hand and repeat the installation."
392    exit 2    exit 2
393  else  else
394    echo Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.      echo $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
395  fi  fi
396  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
397    
398  if [ -x $BINDIR/.run-sml ]; then  #
399    echo Script $BINDIR/.run-sml already exists.  # Function to install a "driver" script...
400  else  #   This takes care of patching the source of the script with the SHELL,
401    cat $CONFIGDIR/_run-sml | \  #   BINDIR, and VERSION variables to use.
402      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  #
403      > $BINDIR/.run-sml  installdriver() {
404    chmod 555 $BINDIR/.run-sml      dsrc=$1
405    if [ ! -x $BINDIR/.run-sml ]; then      ddst=$2
406      echo "!!! Installation of $BINDIR/.run-sml failed for some reason."  # We install the driver unconditionally. (It would be better to test
407    # for an outdated driver script, but not all "test" commands understand
408    # the -nt comparison operator....)
409    #   if [ -x $BINDIR/$ddst ]; then
410    #       echo $this: Script $BINDIR/$ddst already exists.
411    #   else
412            rm -f $BINDIR/$ddst
413            cat $CONFIGDIR/$dsrc | \
414            sed -e "s,@SHELL@,$SHELL,g" \
415                -e "s,@BINDIR@,$BINDIR," \
416                -e "s,@VERSION@,$VERSION," \
417                > $BINDIR/$ddst
418            chmod 555 $BINDIR/$ddst
419            if [ ! -x $BINDIR/$ddst ]; then
420                echo "$this: !!! Installation of $BINDIR/${ddst} failed."
421      exit 1      exit 1
422    fi    fi
423  fi  #   fi
424    }
425    
426    installdriver _run-sml .run-sml
427    installdriver _link-sml .link-sml
428    installdriver _ml-build ml-build
429    
430  #  #
431  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
432  #  #
433  case $ARCH in  case $ARCH in
434    mips*) ALLOC=1M ;;      mips*)
435            ALLOC=1M
436            ;;
437    x86)    x86)
438      ALLOC=256k      ALLOC=256k
439    ;;    ;;
# Line 272  Line 444 
444      ALLOC=512k      ALLOC=512k
445    ;;    ;;
446  esac  esac
447    
448  case $OPSYS in  case $OPSYS in
449    solaris)    solaris)
450      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 279  Line 452 
452    linux)    linux)
453      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
454      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
455        echo "!!! Problems checking for underscores in global names."              echo "$this: !!! Problems checking for underscores in asm names."
456        exit 1        exit 1
457      fi      fi
458      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
# Line 289  Line 462 
462  #  #
463  # the name of the bin files directory  # the name of the bin files directory
464  #  #
465  BOOT_FILES=comp.boot.$ARCH-unix  BOOT_FILES=sml.boot.$ARCH-unix
466    
467  #  #
468  # build the run-time system  # build the run-time system
469  #  #
470  unpack "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime  unpack "run-time" $SRCDIR runtime runtime
471  if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
472        echo $this: Run-time system already exists.
473    else
474    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
475    echo Compiling the run-time system.      echo $this: Compiling the run-time system.
476    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
477    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
478      mv run.$ARCH-$OPSYS $RUNDIR      mv run.$ARCH-$OPSYS $RUNDIR
479      $MAKE MAKE=$MAKE clean          # $MAKE MAKE=$MAKE clean
480    else    else
481      echo "!!! Run-time system build failed for some reason."          echo "$this: !!! Run-time system build failed for some reason."
482      exit 1      exit 1
483    fi    fi
484  fi  fi
# Line 313  Line 488 
488  # boot the base SML system  # boot the base SML system
489  #  #
490  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
491    echo Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.      echo $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
492  else  else
493    unpack bin $ROOT $BOOT_FILES $ROOT/$VERSION-$BOOT_FILES      unpack bin $ROOT $BOOT_FILES $BOOT_FILES
494    cd $ROOT      cd $ROOT/$BOOT_FILES
495    if $RUNDIR/run.$ARCH-$OPSYS @SMLheap=sml \      if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
         @SMLboot=$ROOT/$BOOT_FILES @SMLrtpid=`cat $BOOT_FILES/RTPID` \  
         @SMLalloc=$ALLOC  
496    then    then
497            cd $ROOT
498      if [ -r sml.$HEAP_SUFFIX ]; then      if [ -r sml.$HEAP_SUFFIX ]; then
499          mv sml.$HEAP_SUFFIX $HEAPDIR          mv sml.$HEAP_SUFFIX $HEAPDIR
500          cd $BINDIR          cd $BINDIR
501          ln -s .run-sml sml          ln -s .run-sml sml
   
502          #          #
503          # Now move all stable libraries to #LIBDIR and generate          # Now move all stable libraries to #LIBDIR and generate
504          # the pathconfig file.          # the pathconfig file.
505          #          #
   
506          cd $ROOT/$BOOT_FILES          cd $ROOT/$BOOT_FILES
507          for lib in *.cm ; do              for anchor in * ; do
508              echo $lib $LIBDIR/$lib >>$CM_PATHCONFIG_DEFAULT                  if [ -d $anchor ] ; then
509              movelib $ROOT/$BOOT_FILES/$lib $lib                      echo $anchor $anchor >>$CM_PATHCONFIG_DEFAULT
510                        move $anchor $LIBDIR/$anchor
511                    fi
512          done          done
513          cd $ROOT          cd $ROOT
514                # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
515          rm -rf $BOOT_FILES          rm -rf $BOOT_FILES
516    
517      else      else
518          echo "!!! Boot code did not produce heap image (sml.$HEAP_SUFFIX)."              echo "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
519          exit 1          exit 1
520      fi      fi
521    else    else
522      echo "!!! Boot code failed, no heap image built (sml.$HEAP_SUFFIX)."          echo "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
523      exit 1      exit 1
524    fi    fi
525  fi  fi
# Line 360  Line 535 
535  # now build (or prepare to build) the individual targets  # now build (or prepare to build) the individual targets
536  #  #
537  cd $SRCDIR  cd $SRCDIR
538  echo Installing other targets.  echo $this: Installing other targets.
539  for i in $TARGETS ; do  for i in $TARGETS ; do
540      case $i in      case $i in
541        src-smlnj)        src-smlnj)
542          for src in compiler comp-lib cm MLRISC smlnj-lib ml-yacc system          for src in compiler cm MLRISC smlnj-lib ml-yacc system
543          do          do
544              unpack $src $ROOT/src $src $ROOT/$VERSION-$src              unpack $src $ROOT/src $src $src
545          done          done
546          ;;          ;;
547        ml-yacc)        ml-yacc)
548          standalone ml-yacc ML-Yacc src          standalone ml-yacc ML-Yacc src
549            echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
550          ;;          ;;
551        ml-lex)        ml-lex)
552          standalone ml-lex ML-Lex          standalone ml-lex ML-Lex
553            echo ml-lex $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
554          ;;          ;;
555        ml-burg)        ml-burg)
556          standalone ml-burg ML-Burg          standalone ml-burg ML-Burg
557            echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
558          ;;          ;;
559        smlnj-lib)        smlnj-lib)
560          unpack "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib          unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib
561    
562          # Don't make the Util library -- it came pre-made and has been          # Don't make the Util library -- it came pre-made and has been
563          # installed when making the base system.  In other words, don't do...          # installed when making the base system.  In other words, don't do...
564              #reglib smlnj-lib.cm smlnj-lib/Util              #reglib smlnj-lib.cm smlnj-lib/Util
565            # ... and don't make the HTML library ...
566                #reglib html-lib.cm smlnj-lib/HTML
567            # ... and don't make the PP library ...
568                #reglib pp-lib.cm smlnj-lib/PP
569          # make the Unix library          # make the Unix library
570              reglib unix-lib.cm smlnj-lib/Unix              reglib unix-lib.cm smlnj-lib/Unix
571          # make the INet library          # make the INet library
572              reglib inet-lib.cm smlnj-lib/INet              reglib inet-lib.cm smlnj-lib/INet
         # make the HTML library  
             reglib html-lib.cm smlnj-lib/HTML  
         # make the PP library  
             reglib pp-lib.cm smlnj-lib/PP  
573          # make the RegExp library          # make the RegExp library
574              reglib regexp-lib.cm smlnj-lib/RegExp              reglib regexp-lib.cm smlnj-lib/RegExp
575          # make the Reactive library          # make the Reactive library
576              reglib reactive-lib.cm smlnj-lib/Reactive              reglib reactive-lib.cm smlnj-lib/Reactive
577          ;;          ;;
578        cml)        cml)
579          unpack CML $SRCDIR cml $ROOT/$VERSION-cml          unpack CML $SRCDIR cml cml
580          reglib core-cml.cm cml/src/core-cml          reglib core-cml.cm cml/src/core-cml
581          reglib cml.cm cml/src          reglib cml.cm cml/src
582          reglib cml-basis.cm cml          reglib cml-basis.cm cml
583          ;;          ;;
584        cml-lib)        cml-lib)
585          unpack CML $SRCDIR cml $ROOT/$VERSION-cml          unpack CML $SRCDIR cml cml
586          reglib cml-lib.cm cml/cml-lib          reglib cml-lib.cm cml/cml-lib
587          ;;          ;;
588        eXene)        eXene)
589          unpack EXene $SRCDIR eXene $ROOT/$VERSION-eXene          unpack EXene $SRCDIR eXene eXene
590          reglib eXene.cm eXene          reglib eXene.cm eXene
591          ;;          ;;
592        doc)        doc)
593          unpack Doc $ROOT doc $ROOT/$VERSION-doc          unpack Doc $ROOT doc doc
594          cd $ROOT/doc          cd $ROOT/doc
595          build $ROOT          build $ROOT
596          ;;          ;;
597        *)        *)
598          echo "!!! Unknown target $i."          echo "$this: !!! Unknown target $i."
599          ;;          ;;
600      esac      esac
601  done  done
# Line 428  Line 606 
606  # $SRCDIR, so we must consult $LOCALPATHCONFIG.  # $SRCDIR, so we must consult $LOCALPATHCONFIG.
607  #  #
608    
609  echo Compiling library code.  echo $this: Compiling library code.
610  echo 'then OS.Process.success else OS.Process.failure);' >>$LIBLIST  echo 'then OS.Process.success else OS.Process.failure);' >>$LIBLIST
611  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then
612      echo Libraries compiled successfully.      echo $this: Libraries compiled successfully.
613  else  else
614      echo "!!! Something went wrong when compiling the libraries."      echo "$this: !!! Something went wrong when compiling the libraries."
615      exit 1      exit 1
616  fi  fi
 rm -f $LIBLIST $LOCALPATHCONFIG  
617    
618  #  #
619  # Finally, move the libraries to their final locations...  # Finally, move the libraries to their final locations...
620  #  #
621    
622  if [ -r $LIBMOVESCRIPT ] ; then  if [ -r $LIBMOVESCRIPT ] ; then
623      echo Moving libraries to $LIBDIR.      echo $this: Moving libraries to $LIBDIR.
624      . $LIBMOVESCRIPT      . $LIBMOVESCRIPT
     rm -f $LIBMOVESCRIPT  
625  fi  fi
626    
627    exit 0

Legend:
Removed from v.429  
changed lines
  Added in v.577

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0